/*******************************************************************************
 *
 * blueMarine - open source photo workflow
 * =======================================
 *
 * Copyright (C) 2003-2010 by Fabrizio Giudici
 * Project home page: http://bluemarine.tidalwave.it
 *
 *******************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 *******************************************************************************
 *
 * $Id$
 *
 ******************************************************************************/
package it.tidalwave.semantic.test;

import java.util.Iterator;
import java.util.SortedSet;
import java.io.PrintWriter;
import it.tidalwave.util.Id;
import it.tidalwave.semantic.other.Repository;
import it.tidalwave.semantic.other.Type;
import org.junit.Test;
import static org.junit.Assert.*;

/*******************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 ******************************************************************************/
public abstract class RepositoryTestSupport<C extends Repository> extends TestSupport<C>
  {
    @Test
    public void testFindOrCreateType()
      throws Exception
      {
        final Type type1 = repository.findOrCreateType(new Id(NS + "Class1"), "Class 1");
        assertNotNull(type1);
//        assertTrue(type1 instanceof GraphTypeImpl);

        final Type type1b = repository.findOrCreateType(new Id(NS + "Class1"), "Class 1");
        assertSame(type1, type1b);

        dump("testFindOrCreateType()", repository, new PrintWriter(System.err, true));
      }

    @Test
    public void testGetAllTypes()
      throws Exception
      {
        final Type type1 = repository.findOrCreateType(new Id(NS + "Class1"), "Class 1");
        final Type type2 = repository.findOrCreateType(new Id(NS + "Class2"), "Class 2");
        final Type type3 = repository.findOrCreateType(new Id(NS + "Class3"), "Class 3");
        final Type type4 = repository.findOrCreateType(new Id(NS + "Class4"), "Class 4");

        final SortedSet<Type> allTypes = repository.getAllTypes();
        assertEquals("Found: " + allTypes, 5, allTypes.size());
        final Iterator<Type> i = allTypes.iterator();
        assertSame(type1, i.next());
        assertSame(type2, i.next());
        assertSame(type3, i.next());
        assertSame(type4, i.next());
        assertEquals("http://www.w3.org/2000/01/rdf-schema#Class", i.next().getId().stringValue());

        dump("testGetAllTypes()", repository, new PrintWriter(System.err, true));
      }
  }
